/*
 * MiTCR <http://milaboratory.com>
 *
 * Copyright (c) 2010-2013:
 *     Bolotin Dmitriy     <bolotin.dmitriy@gmail.com>
 *     Chudakov Dmitriy    <chudakovdm@mail.ru>
 *
 * MiTCR is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.milaboratory.core.sequence.util;

import com.milaboratory.core.sequence.SequenceQuality;
import com.milaboratory.core.sequence.quality.SequenceQualityPhred;

public final class SequenceQualityUtils {
    private SequenceQualityUtils() {
    }

    public static SequenceQualityPhred getGoodQualityObject(int length) {
        return new SequenceQualityPhred(SequenceQuality.Constants.goodQuality, length);
    }

    public static SequenceQuality copy(SequenceQuality qulity) {
        if (qulity.getBaseClass() == SequenceQualityPhred.class) {
            byte[] storage = new byte[qulity.size()];
            for (int i = 0; i < qulity.size(); ++i)
                storage[i] = qulity.rawQualityValue(i);
            return new SequenceQualityPhred(storage);
        }
        throw new RuntimeException("Unsupported quality type");
    }
}
