/*
 * MiTCR <http://milaboratory.com>
 *
 * Copyright (c) 2010-2013:
 *     Bolotin Dmitriy     <bolotin.dmitriy@gmail.com>
 *     Chudakov Dmitriy    <chudakovdm@mail.ru>
 *
 * MiTCR is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.milaboratory.core.sequencing.io.fastq.quality;

abstract class AbstractSequenceQualityFactory implements SequenceQualityFactory {
    protected int qualityCodeOffset;
    protected int qualityCodeFrom;
    protected int qualityCodeTo;
    protected boolean lowerUnSafe;

    public boolean isLowerUnSafe() {
        return lowerUnSafe;
    }

    public void setLowerUnSafe(boolean lowerUnSafe) {
        this.lowerUnSafe = lowerUnSafe;
    }

    public int getQualityCodeFrom() {
        return qualityCodeFrom;
    }

    public void setQualityCodeFrom(int qualityCodeFrom) {
        this.qualityCodeFrom = qualityCodeFrom;
    }

    public int getQualityCodeOffset() {
        return qualityCodeOffset;
    }

    public void setQualityCodeOffset(int qualityCodeOffset) {
        this.qualityCodeOffset = qualityCodeOffset;
    }

    public int getQualityCodeTo() {
        return qualityCodeTo;
    }

    public void setQualityCodeTo(int qualityCodeTo) {
        this.qualityCodeTo = qualityCodeTo;
    }
}
