/*
 * MiTCR <http://milaboratory.com>
 *
 * Copyright (c) 2010-2013:
 *     Bolotin Dmitriy     <bolotin.dmitriy@gmail.com>
 *     Chudakov Dmitriy    <chudakovdm@mail.ru>
 *
 * MiTCR is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.milaboratory.core.sequencing.io.fastq.quality;

import com.milaboratory.core.sequence.SequenceQuality;
import com.milaboratory.core.sequence.quality.SequenceQualityPhred;

class PhredSequenceQualityFactory extends AbstractSequenceQualityFactory {
    public SequenceQuality create(byte[] data) {
        for (int i = 0; i < data.length; i++) {
            data[i] -= qualityCodeOffset;
            if (data[i] > qualityCodeTo)
                throw new WrongQualityStringException(((char) (data[i] + qualityCodeOffset)) + " [" + data[i] + "]");
            if (data[i] < qualityCodeFrom)
                if (!lowerUnSafe)
                    throw new WrongQualityStringException(((char) (data[i] + qualityCodeOffset)) + " [" + data[i] + "]");
                else
                    data[i] = (byte) qualityCodeFrom;
        }
        return new SequenceQualityPhred(data);
    }
}
